<link rel="import" href="chrome://resources/html/polymer.html">

<link rel="import" href="chrome://resources/cr_elements/cr_action_menu/cr_action_menu.html">
<link rel="import" href="chrome://resources/cr_elements/cr_button/cr_button.html">
<link rel="import" href="chrome://resources/cr_elements/cr_icon_button/cr_icon_button.html">
<link rel="import" href="chrome://resources/cr_elements/policy/cr_policy_indicator.html">
<link rel="import" href="chrome://resources/cr_elements/policy/cr_tooltip_icon.html">
<link rel="import" href="chrome://resources/html/i18n_behavior.html">
<link rel="import" href="chrome://resources/html/icon.html">
<link rel="import" href="chrome://resources/html/web_ui_listener_behavior.html">
<link rel="import" href="chrome://resources/polymer/v1_0/iron-flex-layout/iron-flex-layout-classes.html">
<link rel="import" href="../localized_link/localized_link.html">
<link rel="import" href="../../i18n_setup.html">
<link rel="import" href="../deep_linking_behavior.html">
<link rel="import" href="../metrics_recorder.html">
<link rel="import" href="../os_route.html">
<link rel="import" href="../../router.html">
<link rel="import" href="../../settings_shared_css.html">
<link rel="import" href="../../people_page/account_manager_browser_proxy.html">

<dom-module id="settings-account-manager">
  <template>
    <style include="settings-shared iron-flex iron-flex-alignment">
      :host {
        --add-account-margin-top: 16px;
      }

      .account-manager-description {
        color: var(--cr-secondary-text-color);
        display: block;
        max-width: 560px;
      }

      .profile-icon {
        --profile-icon-size: 40px;
        background: center / cover no-repeat;
        border-radius: 50%;
        flex-shrink: 0;
        height: var(--profile-icon-size);
        width: var(--profile-icon-size);
      }

      .profile-icon.device-account-icon {
        --profile-icon-size: 60px;
        margin-top: 20px;
      }

      .device-account-container {
        align-items: center;
        display: flex;
        flex-direction: column;
      }

      .device-account-container .primary {
        font-weight: 500;
        margin-top: 15px;
      }

      .account-list-item {
        padding-inline-end: 8px;
        padding-inline-start: 0;
      }

      #outer {
        margin-inline-end: var(--cr-section-padding);
        margin-inline-start: 60px;
      }

      .middle .secondary {
        overflow: hidden;
        text-overflow: ellipsis;
      }

      .secondary-accounts-policy-indicator {
        margin-inline-end: 12px;
      }

      .settings-box.user-message {
        align-items: flex-end;
      }

      .secondary-accounts-tooltip {
        margin-inline-start: 5px;
        width: 15px;
      }

      #account-list-header > h2 {
        padding-bottom: 12px;
        padding-top: 12px;
      }

      cr-policy-indicator {
        margin-inline-end: 1em;
        margin-top: var(--add-account-margin-top);
      }

      #add-account-button {
        margin-bottom: 12px;
        margin-top: 12px;
      }

      #add-account-icon {
        -webkit-mask-image: url(chrome://resources/images/add.svg);
        background-color: currentColor;
        height: 24px;
        margin-inline-end: 0.5em;
        width: 24px;
      }

      .signed-out-text {
        color: var(--google-red-600);
      }

      .error-badge {
        background: url(chrome://resources/images/error_badge.svg)
            center / cover no-repeat;
        display: block;
        height: 20px;
        left: 60%;
        position: relative;
        top: 60%;
        width: 20px;
      }

      :host-context([dir='rtl']) .error-badge {
        left: auto;
        right: 60%;
      }

      .managed-badge {
        --badge-offset: calc(100% - var(--badge-size)
                             - 2 * var(--padding-size));
        --badge-size: 10px;
        --padding-size: 4px;
        background: var(--google-blue-600);
        border-radius: 50%;
        height: var(--badge-size);
        left: var(--badge-offset);
        padding: var(--padding-size);
        position: relative;
        top: var(--badge-offset);
        width: var(--badge-size);
      }

      .managed-badge > iron-icon {
        --iron-icon-fill-color: white;
        --iron-icon-height: var(--badge-size);
        --iron-icon-width: var(--badge-size);
        display: block;
      }

      :host-context([dir='rtl']) .managed-badge {
        left: auto;
        right: var(--badge-offset);
      }

      .managed-message {
        color: var(--cr-secondary-text-color);
        justify-content: center;
      }

      .managed-message > iron-icon {
        margin-inline-end: 5px;
      }

      .management-status {
        color: var(--cr-secondary-text-color);
        overflow: hidden;
        text-align: end;
        text-overflow: ellipsis;
        width: 18ch;
      }

      .edu-account-label {
        margin-inline-start: 12px;
      }

      .tooltip-primary-account {
        margin-inline-end: 12px;
        margin-inline-start: 12px;
      }

      .no-accounts-message {
        color: var(--cr-secondary-text-color);
        padding: 20px 50px;
        text-align: center;
      }

      .settings-box.border-bottom {
        border-bottom: var(--cr-separator-line);
      }
    </style>

    <!-- Account management description -->
    <div class="settings-box first account-manager-description">
      <settings-localized-link
          localized-string="[[getAccountManagerDescription_()]]"
          link-url="$i18nRaw{accountManagerLearnMoreUrl}">
      </settings-localized-link>
      <div hidden$="[[!isChildUser_]]">
        <p>$i18n{accountManagerChildFirstMessage}</p>
        <p>$i18n{accountManagerChildSecondMessage}</p>
      </div>
    </div>

    <template is="dom-if" if="[[isAccountManagementFlowsV2Enabled_]]">
      <!-- Primary account description -->
      <div class="settings-box first">
        <div class="start two-line account-manager-description">
          <div>
            <h2>$i18n{accountManagerUnmanagedLabel}</h2>
            <settings-localized-link
                localized-string=
                  "$i18n{accountManagerPrimaryAccountDescription}"
                on-link-clicked="goToSyncSettings_">
            </settings-localized-link>
          </div>
        </div>
      </div>

      <template is="dom-if" if="[[isDeviceAccountManaged_]]">
        <div class="settings-box first managed-message">
          <iron-icon icon="[[getManagedAccountTooltipIcon_(isChildUser_,
                            isDeviceAccountManaged_)]]">
          </iron-icon>
          <settings-localized-link
              localized-string=
                "[[getManagementDescription_(isChildUser_, deviceAccount_)]]"
              link-url="$i18nRaw{accountManagerChromeUIManagementURL}">
          </settings-localized-link>
        </div>
      </template>

      <!-- Primary account icon, name and email -->
      <div class="device-account-container" tabIndex="0"
          aria-labelledby="deviceAccountFullName"
          aria-describedby="deviceAccountEmail">
        <div class="profile-icon device-account-icon"
            style="background-image: [[getIconImageSet_(deviceAccount_.pic)]]">
            <template is="dom-if"
                if="[[shouldShowManagedBadge_(isDeviceAccountManaged_,
                      isChildUser_)]]">
              <div class="managed-badge">
                <iron-icon icon="cr:work"></iron-icon>
              </div>
            </template>
        </div>
        <span id="deviceAccountFullName" class="primary" aria-hidden="true">
          [[deviceAccount_.fullName]]
        </span>
        <span id="deviceAccountEmail" class="secondary" aria-hidden="true">
          [[deviceAccount_.email]]
        </span>
      </div>
    </template>

    <!-- Message saying that secondary account signin is not allowed -->
    <div id="settings-box-user-message" class="settings-box first user-message"
        hidden="[[isSecondaryGoogleAccountSigninAllowed_]]">
      <cr-policy-pref-indicator class="secondary-accounts-policy-indicator"
          pref=
          "[[prefs.account_manager.secondary_google_account_signin_allowed]]">
      </cr-policy-pref-indicator>
      <div id="user-message-text" class="secondary">
        [[getSecondaryAccountsDisabledUserMessage_()]]
      </div>
    </div>

    <!-- Secondary Accounts list header -->
    <div class="settings-box first">
      <div id="account-list-header" class="start">
        <h2>
          [[getAccountListHeader_(isChildUser_)]]
          <template is="dom-if" if="[[isAccountManagementFlowsV2Enabled_]]">
            <cr-tooltip-icon
                aria-hidden="true"
                class="secondary-accounts-tooltip"
                icon-class="cr:info-outline"
                tooltip-text="[[getSecondaryAccountsTooltip_(accounts_)]]"
                icon-aria-label="[[getSecondaryAccountsTooltip_(accounts_)]]">
            </cr-tooltip-icon>
          </template>
        </h2>
      </div>
      <cr-button disabled="[[!isSecondaryGoogleAccountSigninAllowed_]]"
          id="add-account-button" on-click="addAccount_"
          deep-link-focus-id$="[[Setting.kAddAccount]]">
        <div id="add-account-icon"></div>
        [[getAddAccountLabel_(isChildUser_,
            isSecondaryGoogleAccountSigninAllowed_)]]
      </cr-button>
    </div>

    <!-- Secondary Accounts list -->
    <div id="outer" class="layout vertical nowrap" role="list">
      <template is="dom-repeat" id="account-list"
          items="[[getAccounts_(accounts_)]]">
        <div class="settings-box account-list-item" role="listitem">

          <div class="profile-icon"
              style="background-image: [[getIconImageSet_(item.pic)]]">
            <template is="dom-if" if="[[!item.isSignedIn]]">
              <span class="error-badge"></span>
            </template>
          </div>

          <div class="middle two-line no-min-width">
            <div class="flex text-elide">
              <!-- If account is signed in, display the full name -->
              <template is="dom-if" if="[[item.isSignedIn]]">
                <span id="fullName-[[index]]"
                    aria-hidden="true">[[item.fullName]]</span>
              </template>
              <!-- Else, display a re-authentication message -->
              <template is="dom-if" if="[[!item.isSignedIn]]">
                <span class="signed-out-text">
                  [[getAccountManagerSignedOutName_(item.unmigrated)]]
                </span>
              </template>

              <div class="secondary" id="email-[[index]]"
                  aria-hidden="true">[[item.email]]</div>
            </div>
          </div>

          <template is="dom-if"
              if="[[shouldShowReauthenticationButton_(item)]]">
            <cr-button title="[[getAccountManagerSignedOutTitle_(item)]]"
                class="reauth-button" on-click="onReauthenticationTap_"
                aria-labelledby$="fullName-[[index]] email-[[index]]">
              [[getAccountManagerSignedOutLabel_(item.unmigrated)]]
            </cr-button>
          </template>

          <!-- If this is the Device Account, display the management status -->
          <template is="dom-if" if="[[item.isDeviceAccount]]">
            <cr-tooltip-icon id="primaryAccountTooltip" aria-hidden="true"
                icon-class="[[getPrimaryAccountTooltipIcon_(isChildUser_)]]"
                class="tooltip-primary-account"
                tooltip-text="[[getPrimaryAccountTooltip_(isChildUser_)]]"
                icon-aria-label="[[getPrimaryAccountTooltip_(isChildUser_)]]">
            </cr-tooltip-icon>
            <span class="management-status"
                aria-labelledby$="fullName-[[index]] email-[[index]]"
                aria-describedby="primaryAccountTooltip">
              [[getManagementLabel_(item)]]
            </span>
          </template>
          <!-- Else, display a hamburger menu for removing the account -->
          <template is="dom-if" if="[[!item.isDeviceAccount]]">
            <!-- Display EDU account labels on secondary accounts for Child
              users -->
            <span hidden$="[[!shouldDisplayEduSecondaryAccountLabel_(
                              isChildUser_)]]"
                class="management-status edu-account-label"
                id="edu-account-label-[[index]]"
                aria-hidden="true">
              $i18n{accountManagerEducationAccountLabel}
            </span>
            <cr-icon-button class="icon-more-vert"
                title="[[getMoreActionsTitle_(item)]]"
                aria-label="[[getMoreActionsTitle_(item)]]"
                aria-describedby$="fullName-[[index]]
                                   edu-account-label-[[index]]"
                on-click="onAccountActionsMenuButtonTap_"
                deep-link-focus-id$="[[Setting.kRemoveAccount]]">
            </cr-icon-button>
          </template>
        </div>
      </template>

      <div class$="[[getBottomBorderClassList_(accounts_)]]">
        <div hidden$="[[!shouldShowNoAccountsMessage_(accounts_)]]"
            class="no-accounts-message">
          $i18n{accountManagerSecondaryAccountDescription}
        </div>
      </div>

      <cr-action-menu role-description="$i18n{menu}">
        <button class="dropdown-item" on-click="onRemoveAccountTap_">
          $i18n{removeAccountLabel}
        </button>
      </cr-action-menu>
    </div>

  </template>
  <script src="account_manager.js"></script>
</dom-module>
